/*
 * Copyright (C) 2008 The Trustees of Columbia University in the City of New York. 
 * All rights reserved.
 *
 * See the file LICENSE included in this distribution for details.
 */

#ifndef _BWSTRUCT_H
#define _BWSTRUCT_H

#include "types.h"
#include "gettimeofday.h"

enum CON_STATE {BW_INIT=0, BW_WARMUP, BW_MEASURE, BW_CLOSE};

#define SOCKBUFLEN 66000

#define WARMUPLEN 5    //5 seconds of warmup
#define BWTESTLEN 10   //10 seconds of test length


struct bwconn {
  int16 sockfd;
  struct timeval starttime;
  struct timeval stoptime;
  struct timeval closetime;
  uint32 bytesrcvd;
  uint32 bytessent;
  CON_STATE state;
  char buf[10000];
  int len;
  int rcvd;
 
  bwconn() {
    state=BW_INIT;
    bytessent=0;
    bytesrcvd=0;
    len=0;
    rcvd=0;
  }
};


#endif
