/*
 * Copyright (C) 2008 The Trustees of Columbia University in the City of New York. 
 * All rights reserved.
 *
 * See the file LICENSE included in this distribution for details.
 */

#ifndef _CLIENTBW_H
#define _CLIENTBW_H

#include "types.h"
#include "bwstruct.h"
#include "threadi.h"

//#define IPADDRLEN 30

class ClientBW {
 private:
  int32 m_uiServerTcpPort;
  char8 m_pchServerIP[IPADDRLEN];
  int32 m_mode;  //0 for TCP 1 for UDP
  int32 m_iBoth; //bothway measurements

  int32 m_iTcpSock;
  //int32 m_iUdpSock;
  int32 m_iPktLen;

  fd_set m_writefds;
  fd_set m_readfds;
  int32 m_sockmax;  

  struct mutex_i m_mutex_running; //mutex
  int32 m_isRunning;              //running
  int32 m_isServerIPport;         //flag to indicate if we have server IP and port

  int32 (*m_callback)(uint32 sbw, uint32 rbw, int32 result, int32 retryafter, int32 isClient, void* pApp);
  void* m_pApp;

 private:
  int32 RunTCP();
  
 public:
  ClientBW();
  ~ClientBW();

  void Initialize(int32 mode, int32 pktlen, int32 both, int32 (*callback)(uint32 sbw, uint32 rbw, int32 result, int32 retryafter, int32 isClient, void* pApp), void* pApp );
  int32 CanNegotiateServer(uint16& cport, uint32& retryafter);
  int32 ServerError(int32 result, int32 retryafter);
  int32 SetServerIPPort(char8* pchServerIP, uint16 sport);
  int32 Run();
  int32 ReportResults(struct bwconn& stbwconn, int32 result, int32 retryafter);
  int32 isRunning(uint32& retryafter);
};

#endif

