/*
 * Copyright (C) 2008-2009 The Trustees of Columbia University in the City of New York. 
 * All rights reserved.
 *
 * See the file LICENSE included in this distribution for details.
 */

#ifndef _SOCKETI_H
#define _SOCKETI_H

#ifndef _WENGO
#include "types.h"
#endif

#ifdef _WENGO
#include "p2pp/common/types.h"
#endif 

#ifdef _LINUX_
#include <sys/types.h>  //socket
#include <sys/socket.h> //socket
#include <netinet/in.h> //hton, ntoh
#include <arpa/inet.h>  //inet_addr
#endif

#ifdef WIN32
#include <windows.h>
#include <winsock.h>
#endif

enum SOCK_OPTIONS {S_TCP_NODELAY=10, S_TCP_QUICKACK, S_TCP_INFO, S_SNDBUF, S_RCVBUF, S_WQ, 
		   S_RQ, S_TCP_BLOCK, S_TCP_NONBLOCK};

#ifdef WIN32
typedef int socklen_t;
int close(int s);
unsigned long inet_aton(const char* cp, struct in_addr* pin);
#endif


struct _tcp_info {
 uint32 tcpi_snd_cwnd;
  uint32 tcpi_snd_ssthresh;
  uint32 tcpi_snd_mss;
  uint32 tcpi_rcv_mss;
  uint32 tcpi_lost;
  uint32 tcpi_total_retrans;
  uint32 tcpi_rtt;
  uint32 tcpi_rcv_rtt;
  uchar  tcpi_ca_state;

public:
  _tcp_info()  {
    tcpi_snd_cwnd=1;
    tcpi_snd_ssthresh=1;
    tcpi_snd_mss=1;
    tcpi_rcv_mss=1;
    tcpi_lost=1;
    tcpi_total_retrans=1;
    tcpi_ca_state=1;
  }
};


int32 bindi(int32 sockid, uint16 port);
int32 sendtoi(int32 sockfd, char* data, int32 size, char* ip, int32 port);

int32 selectforsocket(int32 sockfd, int32 timeoutval);
int32 getSockAddr_in(char *pchIP, int port, struct sockaddr_in *pstaddr);

int32 getsockopti_tcp(int32 sockid, enum SOCK_OPTIONS options, void* optval, int* optlen);
int32 setsockopti_tcp(int32 sockid, enum SOCK_OPTIONS options, const void* optval, int optlen);


#endif


