/*
 * Copyright (C) 2008 The Trustees of Columbia University in the City of New York. 
 * All rights reserved.
 *
 * See the file LICENSE included in this distribution for details.
 */

#ifndef _THREADI_H
#define _THREADI_H

#include "types.h"


#ifdef _LINUX_
#include <pthread.h>
#endif

#ifdef WIN32
#include <windows.h>
#endif

struct mutex_i {
#ifdef WIN32
  HANDLE mutexI;
#endif

#ifdef _LINUX_
  pthread_mutex_t mutexI;
#endif
};


int32 CreateThreadI(void *(*start_routine)(void*), void *arg);
int32 DetachThread(int32 iThread);
int32 WaitForThread(int32 iThread);
int32 ExitThread(int32 iThread);
int32 KillThread(int32 iThread);
int32 SuspendThread(int32 iThread);
int32 ResumeThread(int32 iThread);


//OS independent mutex functions
int32 allocmutex_i(struct mutex_i* pstMutex);
int32 lockmutex_i(struct mutex_i* pstMutex);
int32 trylockmutex_i(struct mutex_i* pstMutex); 
int32 unlockmutex_i(struct mutex_i* pstMutex);
int32 deallocmutex_i(struct mutex_i* pstMutex);

#endif

